/**
 */
package org.etsi.mts.tdl.impl;

import java.lang.reflect.InvocationTargetException;

import java.util.Iterator;
import java.util.List;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.IdResolver.IdResolverExtension;
import org.eclipse.ocl.pivot.library.collection.CollectionAsOrderedSetOperation;
import org.eclipse.ocl.pivot.library.collection.CollectionIncludingOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsSetOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsTypeOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclIsKindOfOperation;
import org.eclipse.ocl.pivot.messages.PivotMessages;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.OrderedSetValue;
import org.eclipse.ocl.pivot.values.SetValue;
import org.etsi.mts.tdl.AtomicBehaviour;
import org.etsi.mts.tdl.Behaviour;
import org.etsi.mts.tdl.Block;
import org.etsi.mts.tdl.ComponentInstance;
import org.etsi.mts.tdl.Element;
import org.etsi.mts.tdl.GateReference;
import org.etsi.mts.tdl.Quiescence;
import org.etsi.mts.tdl.TestConfiguration;
import org.etsi.mts.tdl.TestDescription;
import org.etsi.mts.tdl.TimeOperation;
import org.etsi.mts.tdl.tdlPackage;
import org.etsi.mts.tdl.tdlTables;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Quiescence</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.etsi.mts.tdl.impl.QuiescenceImpl#getGateReference <em>Gate Reference</em>}</li>
 * </ul>
 *
 * @generated
 */
public class QuiescenceImpl extends TimeOperationImpl implements Quiescence
{
	/**
	 * The cached value of the '{@link #getGateReference() <em>Gate Reference</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGateReference()
	 * @generated
	 * @ordered
	 */
	protected GateReference gateReference;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected QuiescenceImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return tdlPackage.Literals.QUIESCENCE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public GateReference getGateReference()
	{
		if (gateReference != null && gateReference.eIsProxy()) {
			InternalEObject oldGateReference = (InternalEObject)gateReference;
			gateReference = (GateReference)eResolveProxy(oldGateReference);
			if (gateReference != oldGateReference) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, tdlPackage.QUIESCENCE__GATE_REFERENCE, oldGateReference, gateReference));
			}
		}
		return gateReference;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GateReference basicGetGateReference()
	{
		return gateReference;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setGateReference(GateReference newGateReference)
	{
		GateReference oldGateReference = gateReference;
		gateReference = newGateReference;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, tdlPackage.QUIESCENCE__GATE_REFERENCE, oldGateReference, gateReference));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public EList<ComponentInstance> getParticipatingComponents()
	{
		/**
		 *
		 * if
		 *   self.getParentTestDescription()
		 *   ->exists(td | td.isLocallyOrdered) and
		 *   self.container()
		 *   .oclIsKindOf(Block)
		 * then
		 *   if
		 *     not self.componentInstance.oclIsUndefined() or
		 *     not self.gateReference.oclIsUndefined()
		 *   then
		 *     self.componentInstance->including(self.gateReference.component)
		 *     ->asOrderedSet()
		 *   else
		 *     self.container()
		 *     .oclAsType(Block)
		 *     .getParticipatingComponentsExcluding(self)
		 *     ->asOrderedSet()
		 *   endif
		 * else
		 *   self.getParentTestDescription()
		 *   .testConfiguration.componentInstance->asOrderedSet()
		 * endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ org.eclipse.ocl.pivot.Class TYP_tdl_c_c_Block_0 = idResolver.getClass(tdlTables.CLSSid_Block, null);
		final /*@NonInvalid*/ Element container = this.container();
		final /*@NonInvalid*/ TestDescription getParentTestDescription_0 = this.getParentTestDescription();
		final /*@NonInvalid*/ SetValue oclAsSet = OclAnyOclAsSetOperation.INSTANCE.evaluate(executor, tdlTables.SET_CLSSid_TestDescription, getParentTestDescription_0);
		/*@Thrown*/ Object accumulator = ValueUtil.FALSE_VALUE;
		Iterator<Object> ITERATOR_td = oclAsSet.iterator();
		/*@NonInvalid*/ Boolean exists;
		while (true) {
			if (!ITERATOR_td.hasNext()) {
				if (accumulator == ValueUtil.FALSE_VALUE) {
					exists = ValueUtil.FALSE_VALUE;
				}
				else {
					throw (InvalidValueException)accumulator;
				}
				break;
			}
			/*@NonInvalid*/ TestDescription td = (TestDescription)ITERATOR_td.next();
			/**
			 * td.isLocallyOrdered
			 */
			final /*@NonInvalid*/ boolean isLocallyOrdered = td.isIsLocallyOrdered();
			//
			if (isLocallyOrdered) {					// Normal successful body evaluation result
				exists = ValueUtil.TRUE_VALUE;
				break;														// Stop immediately
			}
			else if (!isLocallyOrdered) {				// Normal unsuccessful body evaluation result
				;															// Carry on
			}
			else {															// Impossible badly typed result
				accumulator = new InvalidValueException(PivotMessages.NonBooleanBody, "exists");
			}
		}
		final /*@Thrown*/ Boolean and;
		if (exists == ValueUtil.FALSE_VALUE) {
			and = ValueUtil.FALSE_VALUE;
		}
		else {
			final /*@NonInvalid*/ boolean oclIsKindOf = OclAnyOclIsKindOfOperation.INSTANCE.evaluate(executor, container, TYP_tdl_c_c_Block_0).booleanValue();
			if (!oclIsKindOf) {
				and = ValueUtil.FALSE_VALUE;
			}
			else {
				if (exists == null) {
					and = null;
				}
				else {
					and = ValueUtil.TRUE_VALUE;
				}
			}
		}
		if (and == null) {
			throw new InvalidValueException("Null if condition");
		}
		/*@Thrown*/ OrderedSetValue local_1;
		if (and) {
			final /*@NonInvalid*/ ComponentInstance componentInstance_0 = this.getComponentInstance();
			final /*@NonInvalid*/ GateReference gateReference_0 = this.getGateReference();
			final /*@NonInvalid*/ boolean oclIsUndefined = componentInstance_0 == null;
			final /*@NonInvalid*/ Boolean not;
			if (!oclIsUndefined) {
				not = ValueUtil.TRUE_VALUE;
			}
			else {
				if (oclIsUndefined) {
					not = ValueUtil.FALSE_VALUE;
				}
				else {
					not = null;
				}
			}
			final /*@Thrown*/ Boolean or;
			if (not == ValueUtil.TRUE_VALUE) {
				or = ValueUtil.TRUE_VALUE;
			}
			else {
				final /*@NonInvalid*/ boolean oclIsUndefined_0 = gateReference_0 == null;
				final /*@NonInvalid*/ Boolean not_0;
				if (!oclIsUndefined_0) {
					not_0 = ValueUtil.TRUE_VALUE;
				}
				else {
					if (oclIsUndefined_0) {
						not_0 = ValueUtil.FALSE_VALUE;
					}
					else {
						not_0 = null;
					}
				}
				if (not_0 == ValueUtil.TRUE_VALUE) {
					or = ValueUtil.TRUE_VALUE;
				}
				else {
					if ((not == null) || (not_0 == null)) {
						or = null;
					}
					else {
						or = ValueUtil.FALSE_VALUE;
					}
				}
			}
			if (or == null) {
				throw new InvalidValueException("Null if condition");
			}
			/*@Thrown*/ OrderedSetValue local_0;
			if (or) {
				final /*@Thrown*/ SetValue oclAsSet_0 = OclAnyOclAsSetOperation.INSTANCE.evaluate(executor, tdlTables.SET_CLSSid_ComponentInstance, componentInstance_0);
				if (gateReference_0 == null) {
					throw new InvalidValueException("Null source for \'\'http://www.etsi.org/spec/TDL/1.4.1\'::GateReference::component\'");
				}
				final /*@Thrown*/ ComponentInstance component = gateReference_0.getComponent();
				final /*@Thrown*/ SetValue including = (SetValue)CollectionIncludingOperation.INSTANCE.evaluate(oclAsSet_0, component);
				final /*@Thrown*/ OrderedSetValue asOrderedSet = CollectionAsOrderedSetOperation.INSTANCE.evaluate(including);
				local_0 = asOrderedSet;
			}
			else {
				final /*@Thrown*/ Block oclAsType = (Block)OclAnyOclAsTypeOperation.INSTANCE.evaluate(executor, container, TYP_tdl_c_c_Block_0);
				final /*@Thrown*/ List<ComponentInstance> getParticipatingComponentsExcluding = oclAsType.getParticipatingComponentsExcluding(this);
				final /*@Thrown*/ OrderedSetValue BOXED_getParticipatingComponentsExcluding = idResolver.createOrderedSetOfAll(tdlTables.ORD_CLSSid_ComponentInstance, getParticipatingComponentsExcluding);
				final /*@Thrown*/ OrderedSetValue asOrderedSet_0 = CollectionAsOrderedSetOperation.INSTANCE.evaluate(BOXED_getParticipatingComponentsExcluding);
				local_0 = asOrderedSet_0;
			}
			local_1 = local_0;
		}
		else {
			final /*@NonInvalid*/ TestConfiguration testConfiguration = getParentTestDescription_0.getTestConfiguration();
			final /*@NonInvalid*/ List<ComponentInstance> componentInstance_1 = testConfiguration.getComponentInstance();
			final /*@NonInvalid*/ SetValue BOXED_componentInstance_1 = idResolver.createSetOfAll(tdlTables.SET_CLSSid_ComponentInstance, componentInstance_1);
			final /*@NonInvalid*/ OrderedSetValue asOrderedSet_1 = CollectionAsOrderedSetOperation.INSTANCE.evaluate(BOXED_componentInstance_1);
			local_1 = asOrderedSet_1;
		}
		final /*@Thrown*/ List<ComponentInstance> ECORE_local_1 = ((IdResolverExtension)idResolver).ecoreValueOfAll(ComponentInstance.class, local_1);
		return (EList<ComponentInstance>)ECORE_local_1;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType)
	{
		switch (featureID) {
			case tdlPackage.QUIESCENCE__GATE_REFERENCE:
				if (resolve) return getGateReference();
				return basicGetGateReference();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue)
	{
		switch (featureID) {
			case tdlPackage.QUIESCENCE__GATE_REFERENCE:
				setGateReference((GateReference)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID)
	{
		switch (featureID) {
			case tdlPackage.QUIESCENCE__GATE_REFERENCE:
				setGateReference((GateReference)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID)
	{
		switch (featureID) {
			case tdlPackage.QUIESCENCE__GATE_REFERENCE:
				return gateReference != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedOperationID(int baseOperationID, Class<?> baseClass)
	{
		if (baseClass == Behaviour.class) {
			switch (baseOperationID) {
				case tdlPackage.BEHAVIOUR___GET_PARTICIPATING_COMPONENTS: return tdlPackage.QUIESCENCE___GET_PARTICIPATING_COMPONENTS;
				default: return super.eDerivedOperationID(baseOperationID, baseClass);
			}
		}
		if (baseClass == AtomicBehaviour.class) {
			switch (baseOperationID) {
				case tdlPackage.ATOMIC_BEHAVIOUR___GET_PARTICIPATING_COMPONENTS: return tdlPackage.QUIESCENCE___GET_PARTICIPATING_COMPONENTS;
				default: return super.eDerivedOperationID(baseOperationID, baseClass);
			}
		}
		if (baseClass == TimeOperation.class) {
			switch (baseOperationID) {
				case tdlPackage.TIME_OPERATION___GET_PARTICIPATING_COMPONENTS: return tdlPackage.QUIESCENCE___GET_PARTICIPATING_COMPONENTS;
				default: return super.eDerivedOperationID(baseOperationID, baseClass);
			}
		}
		return super.eDerivedOperationID(baseOperationID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException
	{
		switch (operationID) {
			case tdlPackage.QUIESCENCE___GET_PARTICIPATING_COMPONENTS:
				return getParticipatingComponents();
		}
		return super.eInvoke(operationID, arguments);
	}

} //QuiescenceImpl
